<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UIPeer.PriceTypeIds StructType
 * @subpackage Structs
 */
class UIPeer_PriceTypeIds extends AnyEntity
{
    /**
     * The PMId
     * Meta information extracted from the WSDL
     * - base: xs:string
     * - minOccurs: 0
     * - nillable: true
     * - pattern: [\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}
     * - type: tns:guid
     * @var string
     */
    public $PMId;
    /**
     * Constructor method for UIPeer.PriceTypeIds
     * @uses UIPeer_PriceTypeIds::setPMId()
     * @param string $pMId
     */
    public function __construct($pMId = null)
    {
        $this
            ->setPMId($pMId);
    }
    /**
     * Get PMId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPMId()
    {
        return isset($this->PMId) ? $this->PMId : null;
    }
    /**
     * Set PMId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $pMId
     * @return \patest\StructType\UIPeer_PriceTypeIds
     */
    public function setPMId($pMId = null)
    {
        // validation for constraint: string
        if (!is_null($pMId) && !is_string($pMId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pMId, true), gettype($pMId)), __LINE__);
        }
        // validation for constraint: pattern([\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12})
        if (!is_null($pMId) && !preg_match('/[\\da-fA-F]{8}-[\\da-fA-F]{4}-[\\da-fA-F]{4}-[\\da-fA-F]{4}-[\\da-fA-F]{12}/', $pMId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression [\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}', var_export($pMId, true)), __LINE__);
        }
        if (is_null($pMId) || (is_array($pMId) && empty($pMId))) {
            unset($this->PMId);
        } else {
            $this->PMId = $pMId;
        }
        return $this;
    }
}
